mailing list of musl libc
 help / color / mirror / code / Atom feed
From: Assaf Gordon <assafgordon@gmail.com>
To: musl@lists.openwall.com, "Rich Felker" <dalias@libc.org>,
	"Niklas Hambüchen" <mail@nh2.me>
Cc: coreutils@gnu.org, mjbauer95@gmail.com
Subject: Re: Re: date-debug test failure with musl
Date: Mon, 13 May 2019 16:49:52 -0600	[thread overview]
Message-ID: <98551500-3d6a-d123-d1d4-a47a0c6619e1@gmail.com> (raw)
In-Reply-To: <20190513182339.GR23599@brightrain.aerifal.cx>

[-- Attachment #1: Type: text/plain, Size: 817 bytes --]

Hello,

On 2019-05-13 12:23 p.m., Rich Felker wrote:
> On Mon, May 13, 2019 at 05:02:48AM +0200, Niklas Hambüchen wrote:
>> Dear coreutils maintainers,
>>
>> when compiling coreutils commit 6e97d36 against musl v1.1.22 on Ubuntu, I get a test failure and differing output than when using glibc.

Thank you for the report,

[...]

> As long as coreutils' date is producing the desired "invalid" error
> either way, which it seems to be, I think it's a mistake that the
> debug output for "normalized time" is being compared as part of the
> test assertion. Only the result should matter, not the path by which
> it's reached.

And thank you Rich for the quick analysis.

The attached patch implements your suggestion.

It works on glibc, please give it a test on your Ubuntu/musl-1.1.22 system.

regards,
  - assaf



[-- Warning: decoded text below may be mangled, UTF-8 assumed --]
[-- Attachment #2: 0001-tests-avoid-false-positive-in-date-debug-test.patch --]
[-- Type: text/x-patch; name="0001-tests-avoid-false-positive-in-date-debug-test.patch", Size: 2148 bytes --]

From 402c3646e19c199130e7a6db5238cf5908e51fb8 Mon Sep 17 00:00:00 2001
From: Assaf Gordon <assafgordon@gmail.com>
Date: Mon, 13 May 2019 16:37:40 -0600
Subject: [PATCH] tests: avoid false-positive in date-debug test
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

When debugging an invalid date due to DST switching, the intermediate
'normalized time' should not be checked - its value can differ between
systems (e.g. glibc vs musl).

Reported by Niklas Hambüchen in
https://lists.gnu.org/r/coreutils/2019-05/msg00031.html
Analyzed by Rich Felker in
https://lists.gnu.org/r/coreutils/2019-05/msg00039.html

* tests/misc/date-debug.sh: Replace the exact normalized time
with 'XX:XX:XX' so different values would not trigger test failure.
---
 tests/misc/date-debug.sh | 11 +++++++++--
 1 file changed, 9 insertions(+), 2 deletions(-)

diff --git a/tests/misc/date-debug.sh b/tests/misc/date-debug.sh
index aa47f1abb..2ce6f4ce8 100755
--- a/tests/misc/date-debug.sh
+++ b/tests/misc/date-debug.sh
@@ -71,7 +71,7 @@ date: input timezone: TZ="America/Edmonton" in date string
 date: using specified time as starting value: '02:30:00'
 date: error: invalid date/time value:
 date:     user provided time: '(Y-M-D) 2006-04-02 02:30:00'
-date:        normalized time: '(Y-M-D) 2006-04-02 03:30:00'
+date:        normalized time: '(Y-M-D) 2006-04-02 XX:XX:XX'
 date:                                             --
 date:      possible reasons:
 date:        non-existing due to daylight-saving time;
@@ -81,7 +81,14 @@ date: invalid date 'TZ="America/Edmonton" 2006-04-02 02:30:00'
 EOF
 
 # date should return 1 (error) for invalid date
-returns_ 1 date --debug -d "$in2" >out2 2>&1 || fail=1
+returns_ 1 date --debug -d "$in2" >out2-t 2>&1 || fail=1
+
+# The output line of "normalized time" can differ between systems
+# (e.g. glibc vs musl) and should not be checked.
+# See: https://lists.gnu.org/archive/html/coreutils/2019-05/msg00039.html
+sed '/normalized time:/s/ [0-9][0-9]:[0-9][0-9]:[0-9][0-9]/ XX:XX:XX/' \
+    out2-t > out2 || framework_failure_
+
 compare exp2 out2 || fail=1
 
 ##
-- 
2.11.0


  reply	other threads:[~2019-05-13 22:49 UTC|newest]

Thread overview: 6+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
     [not found] <87929f3b-ce4d-cd2d-0baf-dfae49fee58e@nh2.me>
2019-05-13 18:23 ` Rich Felker
2019-05-13 22:49   ` Assaf Gordon [this message]
     [not found]     ` <98551500-3d6a-d123-d1d4-a47a0c6619e1-Re5JQEeQqe8AvxtiuMwx3w@public.gmane.org>
2019-05-14 13:38       ` [musl] " Niklas Hambüchen
     [not found]         ` <26965951-d4f2-ae57-2b7e-b307fc39d60f-7wQd5C9ZzNw@public.gmane.org>
2019-05-16 17:52           ` Niklas Hambüchen
2019-06-13  3:35             ` Assaf Gordon
2019-06-13 12:58               ` Niklas Hambüchen

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=98551500-3d6a-d123-d1d4-a47a0c6619e1@gmail.com \
    --to=assafgordon@gmail.com \
    --cc=coreutils@gnu.org \
    --cc=dalias@libc.org \
    --cc=mail@nh2.me \
    --cc=mjbauer95@gmail.com \
    --cc=musl@lists.openwall.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://git.vuxu.org/mirror/musl/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).